"use strict";

const os = require("os");

module.exports = cb => {
  const platform = os.platform();

  if (/^linux|darwin|win32$/.test(platform)) {
    return require("./" + platform)(cb);
  } else {
    throw new Error("Unsupported Platform: " + platform);
  }
};
