const {expect} = require("chai");
const defaultNetwork = require(".");
const net = require("net");
const os = require("os");

describe("default-network", () =>
  describe("run", function() {
    let data = null;
    before(done =>
      defaultNetwork(function(error, result) {
        data = result;
        // console.log "data", data
        // console.log "interfaces", os.networkInterfaces()
        return done(error);
      })
    );
    it("has interface names which are included in os.networkInterfaces()", () =>
      (() => {
        const result = [];
        Object.keys(data).forEach(iface => {
          result.push(expect(os.networkInterfaces()).to.include.keys(iface));
        });
        return result;
      })()
    );
    return it("has values which include a family and an address", () =>
      (() => {
        const result = [];
        Object.keys(data).forEach(iface => {
          const values = data[iface];
          result.push((() => {
            const result1 = [];
            for (const value of Array.from(values)) {
              let item;
              expect(["IPv4", "IPv6"]).to.include(value.family);
              switch (value.family) {
              case "IPv4":
                item = expect(net.isIPv4(value.address)).to.be.true;
                break;
              case "IPv6":
                item = expect(net.isIPv6(value.address)).to.be.true;
                break;
              }
              result1.push(item);
            }
            return result1;
          })());
        });
        return result;
      })()
    );
  })
);
